ad_page_contract {
    Generate a list of selenium testsuites from the test folder
}

set title "OpenACS Selenium Test Suites"

# you need admin permissions to run these tests
# permission::require_permission \
#    -party_id [ad_conn user_id] \
#    -privilege "admin" \
#    -object_id [acs_magic_object "security_context_root"]

# generate the test suites
selenium::genalltestsuites

# selenium has problems with https
if { [security::https_available_p] } {
	security::require_secure_conn
}

# HAM : 
# TODO : convert this to use list template

# display the table
set content ""
append content "<table border=0 cellpaddng=2 cellspacing=2 width=\"100%\">"
append content "<tr>"
append content "<td align=\"center\" valign=\"top\">Test Suite</td>"
append content "<td align=\"center\" valign=\"top\">Action</td>"
append content "<td align=\"center\" valign=\"top\">Result</td>"
append content "<td align=\"center\" valign=\"top\">Total Time <br>(sec)</td>"
append content "<td align=\"center\" valign=\"top\">No. of Test Pass</td>"
append content "<td align=\"center\" valign=\"top\">No. of Test Fails</td>"
append content "<td align=\"center\" valign=\"top\">No. of Command Pass</td>"
append content "<td align=\"center\" valign=\"top\">No. of Command Fail</td>"
append content "<td align=\"center\" valign=\"top\">No. of Command Errors</td>"
append content "</tr>"
append content "<tr><td colspan=9><hr></td></tr>"

db_multirow "getresults" "queryrestults" { select * from selenium_testsuites order by suite_name } {
	append content "<tr>"
	if { [exists_and_not_null pretty_name] } {
		append content "<td valign=\"top\">${pretty_name}</td>"
	} else {
		append content "<td valign=\"top\">${suite_name}</td>"
	}
	append content "<td align=\"left\" valign=\"top\">				
				<li><a href=\"edit-suite?id=${id}\" >Administer</a></li>"
	if { [selenium::file_count -id $id] > 0 } {
		append content "<li><a href=\"details?id=${id}\" target=\"blank\">Result Details</a></li>
			<li><a href=\"javascript:void(0)\" onClick=\"window.open('selenium/core/TestRunner.html?test=/selenium/tests/testsuite-${suite_name}.html&testsuite_id=${id}&resultsUrl=/selenium/results','opener')\">Manual Run</a></li>
			<li><a href=\"javascript:void(0)\" onClick=\"window.open('selenium/core/TestRunner.html?test=/selenium/tests/testsuite-${suite_name}.html&auto=true&testsuite_id=${id}&resultsUrl=/selenium/results','opener')\">Auto Run</a></li>"
	}
	append content "</td>"

	append content "<td align=\"center\" valign=\"top\">"
	if { $result == "passed" } { set color "green" } else { set color "red" }
	append content "<font color=${color}>$result</font>"
	append content "</td>"
	append content "<td align=\"center\" valign=\"top\">$totaltime</td>"
	append content "<td align=\"center\" valign=\"top\"><font color=\"green\">$numtestpasses</font></td>"
	append content "<td align=\"center\" valign=\"top\"><font color=\"red\">$numtestfailures</font></td>"
	append content "<td align=\"center\" valign=\"top\"><font color=\"green\">$numcommandpasses</font></td>"
	append content "<td align=\"center\" valign=\"top\"><font color=\"red\">$numcommandfailures</font></td>"
	append content "<td align=\"center\" valign=\"top\"><font color=\"red\">$numcommanderrors</font></td>"
	append content "</tr>"
}

append content "</table>"
